import type { InputPaths, InputPathToArray, InputPathToValue } from "@octopusdeploy/step-inputs";
import type { InitialInputs } from "./InitialInputs";
import type { FormContent } from "./FormContent";
import type { CommonInputProps, StepInputComponent } from "./InputComponents";

export type ListFactory = <ArrayItem>(props: ListProps<ArrayItem>) => ListComponent;

export interface ListProps<ArrayItem> extends CommonInputProps {
    input: InputPathToArray<ArrayItem>;
    itemLabel: string;
    newItem: InitialInputs<ArrayItem>;
    itemSummary: (arrayItemInputs: InputPaths<ArrayItem>) => InputPathToValue<string>;
    editItemForm: (arrayItemInputs: InputPaths<ArrayItem>) => FormContent<StepInputComponent>[];
}

export interface ListComponent extends ListProps<unknown> {
    type: "list";
}
